//+------------------------------------------------------------------+
//|                                                     CoinTest.mq4 |
//|                                                          Dubovik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dubovik"
#property link      ""
#property version   "1.00"
#property strict
#property script_show_inputs

#include <CLabouchere.mqh>




//--- input parameters
input int RepeatsCount=100000;
input int StartBalance = 10000;
input int Take = 50;
input double SuccessPercent = 50.0;
//   true - , SuccessPercent 
input bool FiftyFifty = true;




void OnStart()
{
	MathSrand(GetTickCount());

	Calc();
}




//     
//      
void Calc()
{
	// ,     
	int iSuccessLimit = (int) MathRound(32768 * (100 - SuccessPercent) / 100) - 1;

	int iFile = 0;
	//  
	iFile = FileOpen("Coin.csv", FILE_WRITE | FILE_CSV, "\t");

		//    ...
		if ( iFile != INVALID_HANDLE )
		{
			//  
			FileWrite(iFile, " /", " ", " , $", " ", " ");

			//      CLabouchere
			CLabouchere Lab;
			Lab.SetStartLot(1);

			double dLot;
			double dDeal = 0;
			bool bCoin;
			int iBitNumber = 0;
			int iRand = MathRand();
			double dBalance = StartBalance;
				//  -   ,    ,    a_iRepeatsCount 
				for (int i = 0; (i < RepeatsCount) && (dDeal < dBalance); i++)
				{
					//     
					dLot = Lab.GetCurrentLot();

					dDeal = Take * dLot;
						//  
						if (FiftyFifty)
						{
								//   -      
								if (iBitNumber >= 15)
								{
									iRand = MathRand();
									iBitNumber = 0;
								}

							bCoin = (iRand >> iBitNumber) & 1;
							iBitNumber++;
						}
						else
						{
							iRand = MathRand();
							bCoin = iRand > iSuccessLimit;
						}

						if (bCoin)
							dBalance += dDeal;
						else
							dBalance -= dDeal;

					Lab.SetResult(bCoin);

					FileWrite(iFile, i, dLot, dDeal, bCoin, DoubleToString(dBalance, 2));
				}

			FileClose(iFile);
		}
		else
			Print("     ");
}
